package svc

import (
	enum3 "applet/app/admin/enum"
	"applet/app/admin/md"
	svc4 "applet/app/admin/svc"
	svc "applet/app/admin/svc/enterprise_manage"
	enum2 "applet/app/customer/enum"
	md2 "applet/app/customer/md"
	svc2 "applet/app/customer/svc"
	"applet/app/db"
	model2 "applet/app/db/model"
	"applet/app/e"
	"applet/app/enum"
	svc3 "applet/app/svc"
	"applet/app/utils"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/wechatpay-apiv3/wechatpay-go/core"
	"github.com/wechatpay-apiv3/wechatpay-go/services/refunddomestic"
	"math"
	"strings"
	"time"
)

func CentralKitchenForSchoolOrderRefundList(c *gin.Context, req md.CentralKitchenForSchoolOrderRefundListReq) (resp []md.CentralKitchenForSchoolOrderRefundListResp, total int64, err error) {
	var m []*db.CentralKitchenForSchoolUserRefundDayWithData
	sess := db.Db.Where("1=1")
	if req.EnterpriseId != 0 {
		sess.And("enterprise.id =?", req.EnterpriseId)
	}
	if req.Phone != "" {
		sess.And("user.phone like ?", "%"+req.Phone+"%")
	}
	if req.Name != "" {
		sess.And("user_identity.name like ?", "%"+req.Name+"%")
	}
	if req.OrderByName == 1 {
		sess.OrderBy("CONVERT(user_identity.name USING gbk) ASC")
	}
	if req.OrderByName == 2 {
		sess.OrderBy("CONVERT(user_identity.name USING gbk) DESC")
	}
	if req.Kind != 0 {
		sess.And("central_kitchen_for_school_user_with_day.kind = ?", req.Kind)
	}
	if req.State != 0 {
		sess.And("central_kitchen_for_school_user_refund_day.state = ?", req.State)
	}
	if req.StartDate != "" {
		sess.And("central_kitchen_for_school_user_refund_day.create_at >= ?", req.StartDate)
	}
	if req.EndDate != "" {
		sess.And("central_kitchen_for_school_user_refund_day.create_at <= ?", req.EndDate)
	}
	if req.StartRefundTime != "" {
		sess.And("central_kitchen_for_school_user_with_day.date >= ?", req.StartRefundTime)
	}
	if req.EndRefundTime != "" {
		sess.And("central_kitchen_for_school_user_with_day.date <= ?", req.EndRefundTime)
	}
	if req.StartRefundDate != "" {
		sess.And("central_kitchen_for_school_user_refund_day.refund_date >= ?", req.StartRefundDate)
	}
	if req.EndRefundDate != "" {
		sess.And("central_kitchen_for_school_user_refund_day.refund_date <= ?", req.EndRefundDate)
	}
	if req.OutTradeNo != "" {
		sess.And("central_kitchen_for_school_user_refund_day.out_trade_no like ?", "%"+req.OutTradeNo+"%")
	}
	if req.OutRequestNo != "" {
		sess.And("central_kitchen_for_school_user_refund_day.out_request_no like ?", "%"+req.OutRequestNo+"%")
	}
	if req.Memo != "" {
		sess.And("central_kitchen_for_school_user_refund_day.memo like ?", "%"+req.Memo+"%")
	}

	var classWithUserIdentityIdsOne []int
	var classWithUserIdentityIdsTwo []int
	classWithUserDb := db.ClassWithUserDb{}
	classWithUserDb.Set()
	if req.ClassId != 0 {
		classWithUsers, err2 := classWithUserDb.FindUserIdentity(req.ClassId)
		if err2 != nil {
			return nil, 0, err2
		}
		for _, v := range *classWithUsers {
			classWithUserIdentityIdsOne = append(classWithUserIdentityIdsOne, v.UserIdentityId)
		}
		if len(classWithUserIdentityIdsOne) == 0 {
			return
		}
	}
	if req.GradeId != 0 {
		classDb := db.ClassDb{}
		classDb.Set(req.GradeId)
		classes, err3 := classDb.FindClass()
		if err3 != nil {
			return nil, 0, err3
		}
		var classesId []int
		for _, v := range *classes {
			classesId = append(classesId, v.Id)
		}
		classWithUsers, err4 := classWithUserDb.FindUserIdentity(classesId)
		if err4 != nil {
			return nil, 0, err4
		}
		for _, v := range *classWithUsers {
			classWithUserIdentityIdsTwo = append(classWithUserIdentityIdsTwo, v.UserIdentityId)
		}
		if len(classWithUserIdentityIdsTwo) == 0 {
			return
		}
	}

	if req.IsTeacher != 0 {
		//查询出所有教师
		var mm []model2.UserIdentity
		if req.IsTeacher == 1 {
			err2 := db.Db.Where("user_identity.enterprise_id =?", req.EnterpriseId).And("user_identity.identity =?", enum.UserIdentityForCentralKitchenForTeacher).Find(&mm)
			if err2 != nil {
				return nil, 0, err2
			}
		}
		if req.IsTeacher == 2 {
			err2 := db.Db.Where("user_identity.enterprise_id =?", req.EnterpriseId).And("user_identity.identity !=?", enum.UserIdentityForCentralKitchenForTeacher).Find(&mm)
			if err2 != nil {
				return nil, 0, err2
			}
		}
		if len(mm) < 0 {
			return
		}
	}
	if len(classWithUserIdentityIdsOne) > 0 {
		sess.In("user_identity.id", classWithUserIdentityIdsOne)
	}
	if len(classWithUserIdentityIdsTwo) > 0 {
		sess.In("user_identity.id", classWithUserIdentityIdsTwo)
	}
	admin := svc4.GetUser(c)
	if admin.IsSuperAdministrator != enum3.IsSuperAdministratorTure {
		adminWithEnterpriseDb := db.AdminWithEnterpriseDb{}
		adminWithEnterpriseDb.Set()
		adminWithEnterprise, err1 := adminWithEnterpriseDb.FindAdminWithEnterprise(admin.AdmId)
		if err1 != nil {
			e.OutErr(c, e.ERR_DB_ORM, err1.Error())
			return
		}
		var enterPriseIds []int
		for _, v1 := range *adminWithEnterprise {
			enterPriseIds = append(enterPriseIds, v1.EnterpriseId)
		}
		if len(enterPriseIds) == 0 {
			return
		}
		sess.In("central_kitchen_for_school_user_with_day.enterprise_id", enterPriseIds)
	}

	total, err = sess.
		Join("LEFT", "central_kitchen_for_school_user_with_day", "central_kitchen_for_school_user_refund_day.records_id = central_kitchen_for_school_user_with_day.id").
		Join("LEFT", "central_kitchen_for_school_package_ord", "central_kitchen_for_school_user_refund_day.out_trade_no = central_kitchen_for_school_package_ord.out_trade_no").
		Join("LEFT", "user_identity", "central_kitchen_for_school_user_with_day.identity_id = user_identity.id").
		Join("LEFT", "user", "user_identity.uid = user.id").
		Join("LEFT", "enterprise", "user_identity.enterprise_id = enterprise.id").
		Join("LEFT", "class_with_user", "user_identity.id = class_with_user.user_identity_id").
		Join("LEFT", "class", "class_with_user.class_id = class.id").
		Join("LEFT", "grade", "class.grade_id = grade.id").
		Desc("central_kitchen_for_school_user_refund_day.id").
		Limit(req.Limit, (req.Page-1)*req.Limit).FindAndCount(&m)
	if err != nil {
		return nil, 0, err
	}

	for _, v := range m {
		resp = append(resp, md.CentralKitchenForSchoolOrderRefundListResp{
			Id:               v.CentralKitchenForSchoolUserRefundDay.Id,
			OutTradeNo:       v.CentralKitchenForSchoolUserRefundDay.OutTradeNo,
			OutRequestNo:     v.CentralKitchenForSchoolUserRefundDay.OutRequestNo,
			Name:             v.UserIdentity.Name,
			Phone:            v.User.Phone,
			EnterpriseName:   v.Enterprise.Name,
			ClassName:        v.Class.Name,
			GradeName:        v.Grade.Name,
			Kind:             v.CentralKitchenForSchoolUserWithDay.Kind,
			UserIdentityKind: v.UserIdentity.Kind,
			Amount:           v.CentralKitchenForSchoolUserRefundDay.Amount,
			State:            v.CentralKitchenForSchoolUserRefundDay.State,
			CreateAt:         v.CentralKitchenForSchoolUserRefundDay.CreateAt,
			RefundDate:       v.CentralKitchenForSchoolUserRefundDay.RefundDate,
			RefundTime:       v.CentralKitchenForSchoolUserWithDay.Date,
			Memo:             v.CentralKitchenForSchoolUserRefundDay.Memo,
		})
	}
	return
}

func CentralKitchenForSchoolOrderRefundAudit(c *gin.Context, req md.CentralKitchenForSchoolOrderRefundAuditReq) (err error) {
	sysCfgDb := db.SysCfgDb{}
	sysCfgDb.Set()
	sysCfg := sysCfgDb.SysCfgFindWithDb(enum.JsapiPayAppAutToken, enum.OpenAlipayAppid, enum.OpenAlipayAppPrivateKey, enum.OpenAlipayPublicKey, enum.WxJsapiRefundPayNotifyUrl)

	session := db.Db.NewSession()
	defer session.Close()
	session.Begin()

	centralKitchenForSchoolUserRefundDayDb := db.CentralKitchenForSchoolUserRefundDayDb{}
	centralKitchenForSchoolUserRefundDayDb.Set(0)
	centralKitchenForSchoolUserWithDayDb := db.CentralKitchenForSchoolUserWithDayDb{}
	centralKitchenForSchoolUserWithDayDb.Set(0)
	centralKitchenForSchoolPackageOrd := db.CentralKitchenForSchoolPackageOrd{}
	var dealReturnOrdMap = map[string]struct {
		OutRequestNo string  `json:"out_request_no"`
		Amount       float64 `json:"amount"`
	}{}

	var dealReturnOrdMapForWx = map[string]struct {
		OutRequestNo string  `json:"out_request_no"`
		Amount       float64 `json:"amount"`
		Total        string  `json:"total"`
		WxMchId      string  `json:"wx_mch_id"`
	}{}

	var dealReturnOrd = map[string][]string{}

	outRequestNoSuffix := "_" + utils.Int64ToStr(time.Now().Unix())

	companyWithWxpayInfoDb := db.CompanyWithWxpayInfoDb{}
	companyWithWxpayInfoDb.Set()

	var isAlreadyReturnDayId []int
	for _, v := range req.Ids {
		//1、更新状态
		if req.State == 1 {
			returnDay, err1 := centralKitchenForSchoolUserRefundDayDb.GetCentralKitchenForSchoolUserRefundDay(utils.StrToInt(v))
			if err1 != nil {
				_ = session.Rollback()
				return err1
			}

			userWithDay, err3 := centralKitchenForSchoolUserWithDayDb.GetCentralKitchenForSchoolUserWithDay(returnDay.RecordsId)
			if err3 != nil {
				_ = session.Rollback()
				return err3
			}

			//if userWithDay.State == enum.CentralKitchenForSchoolUserWithDayStateForCancel && returnDay.State != enum.CentralKitchenForSchoolUserRefundDayStateForRefundErr {
			//	//TODO::当前订餐记录，已退款了
			//	isAlreadyReturnDayId = append(isAlreadyReturnDayId, returnDay.Id)
			//	continue
			//}

			userWithDay.State = enum.CentralKitchenForSchoolUserWithDayStateForCancel
			outRequestNo := "r_" + returnDay.OutTradeNo + outRequestNoSuffix
			centralKitchenForSchoolPackageOrd.Set(returnDay.OutTradeNo)
			ord, err4 := centralKitchenForSchoolPackageOrd.GetCentralKitchenForSchoolPackageOrd()
			if err4 != nil {
				_ = session.Rollback()
				return err4
			}
			if ord == nil {
				_ = session.Rollback()
				return errors.New("未查询到对应订单记录")
			}

			if ord.PayWay == enum2.PayWayForAli {
				dealReturnOrdMap[returnDay.OutTradeNo] = struct {
					OutRequestNo string  `json:"out_request_no"`
					Amount       float64 `json:"amount"`
				}(struct {
					OutRequestNo string
					Amount       float64
				}{OutRequestNo: outRequestNo, Amount: dealReturnOrdMap[returnDay.OutTradeNo].Amount + utils.StrToFloat64(returnDay.Amount)})
			}

			if ord.PayWay == enum2.PayWayForWx {
				var wxMchId = dealReturnOrdMapForWx[returnDay.OutTradeNo].WxMchId
				if wxMchId == "" {
					wxMchId, err4 = companyWithWxpayInfoDb.GetCompanyWithWxpayInfoByEnterprise(ord.EnterpriseId)
					if err4 != nil {
						_ = session.Rollback()
						return err4
					}
				}
				dealReturnOrdMapForWx[returnDay.OutTradeNo] = struct {
					OutRequestNo string  `json:"out_request_no"`
					Amount       float64 `json:"amount"`
					Total        string  `json:"total"`
					WxMchId      string  `json:"wx_mch_id"`
				}(struct {
					OutRequestNo string
					Amount       float64
					Total        string
					WxMchId      string
				}{OutRequestNo: outRequestNo, Amount: dealReturnOrdMapForWx[returnDay.OutTradeNo].Amount + utils.StrToFloat64(returnDay.Amount), Total: ord.TotalPrice, WxMchId: wxMchId})
			}

			dealReturnOrd[returnDay.OutTradeNo] = append(dealReturnOrd[returnDay.OutTradeNo], utils.IntToStr(returnDay.RecordsId))

			returnDay.OutRequestNo = outRequestNo
			returnDay.State = enum.CentralKitchenForSchoolUserRefundDayStateForAuditComplete
			returnDay.RefundDate = time.Now().Format("2006-01-02 15:04:05")

			returnDay.Memo = req.Memo
			updateAck, err2 := centralKitchenForSchoolUserRefundDayDb.CentralKitchenForSchoolUserRefundDayUpdateBySess(session, returnDay.Id, returnDay, "state", "memo", "refund_date", "out_request_no")
			if err2 != nil {
				_ = session.Rollback()
				return err2
			}
			if updateAck <= 0 {
				_ = session.Rollback()
				err = errors.New("更新退款订单记录状态失败1")
				return
			}

			time.Sleep(20 * time.Millisecond) //TODO::避免频繁操作sql

			updateAck1, err4 := centralKitchenForSchoolUserWithDayDb.CentralKitchenForSchoolUserWithDayUpdateBySess(session, userWithDay.Id, userWithDay, "state")
			if err4 != nil {
				_ = session.Rollback()
				return err4
			}
			if updateAck1 <= 0 {
				//_ = session.Rollback()
				//err = errors.New("更新退款就餐记录状态失败2")
				//return
			}
		}
	}

	session.Commit()

	if len(isAlreadyReturnDayId) > 0 {
		//更改 `central_kitchen_for_school_user_refund_day` 的 memo
		sql := "update central_kitchen_for_school_user_refund_day set memo = '当前退款申请记录，已有其他退款申请完成退款！' where id In  (%s)"
		idsStr := strings.Join(req.Ids, ",")
		sql = fmt.Sprintf(sql, idsStr)
		fmt.Println(sql)
		_, err = db.ExecuteOriginalSql(db.Db, sql)
		if err != nil {
			utils.FilePutContents("isAlreadyReturnDayId_ERR", utils.SerializeStr(map[string]interface{}{
				"sql": sql,
				"err": err.Error(),
			}))
			fmt.Println("isAlreadyReturnDayId_ERR::::::::::::::", err.Error())
		}
	}

	//调用支付宝进行退款
	for k, v := range dealReturnOrdMap {
		err6, _ := svc2.CurlAlipayTradeRefund(md2.CurlAlipayTradeRefundReq{
			Config: struct {
				PayAliAppId      string `json:"pay_ali_app_id" label:"支付宝开放平台-第三方应用-appid"`
				PayAliPrivateKey string `json:"pay_ali_private_key" label:"支付宝开放平台-第三方应用-接口加签-应用私钥"`
				PayAliPublicKey  string `json:"pay_ali_public_key" label:"支付宝开放平台-第三方应用-接口加签-支付宝公钥"`
			}{
				PayAliAppId:      sysCfg[enum.OpenAlipayAppid],
				PayAliPrivateKey: sysCfg[enum.OpenAlipayAppPrivateKey],
				PayAliPublicKey:  sysCfg[enum.OpenAlipayPublicKey],
			},
			OutTradeNo:   k,
			RefundAmount: utils.Float64ToStr(v.Amount),
			RefundReason: "央厨订餐退款",
			OutRequestNo: v.OutRequestNo,
			AppAuthToken: sysCfg[enum.JsapiPayAppAutToken],
		})
		if err6 != nil {
			fmt.Println("dealReturnOrdMap_ERR::::", err6.Error())
			//TODO::1、将 central_kitchen_for_school_user_refund_day 审核状态修改为`退款中`
			var sql string
			sql = fmt.Sprintf("update central_kitchen_for_school_user_refund_day set state =5, memo = '%s' where out_request_no = '%s'", err6.Error(), v.OutRequestNo)
			db.ExecuteOriginalSql(db.Db, sql)

			//TODO::2、将 central_kitchen_for_school_user_with_day 修改状态为退款中
			sql1 := "update central_kitchen_for_school_user_with_day set state = %d where id In  (%s)"
			idsStr := strings.Join(dealReturnOrd[k], ",")
			sql1 = fmt.Sprintf(sql, enum.CentralKitchenForSchoolUserWithDayStateForCanceling, idsStr)
			db.ExecuteOriginalSql(db.Db, sql1)

			utils.FilePutContents("dealReturnOrdMap_ERR", utils.SerializeStr(map[string]interface{}{
				"sql":  sql,
				"sql1": sql1,
				"err":  err6.Error(),
			}))
		} else {
			//TODO::处理订单状态
			err = svc.JudgePackageOrdOrdState(k)
			if err != nil {
				utils.FilePutContents("dealReturnOrdMap_judge_packageOrdState_ERR", utils.SerializeStr(map[string]interface{}{
					"err": err.Error(),
				}))
			}
		}

		time.Sleep(10 * time.Millisecond) //TODO::避免频繁调用
	}

	//调用微信进行退款
	//if !cfg.Prd { //TODO::正式环境暂不开启微信退款
	client, err1 := svc3.NewWxPayClient(c) //初始化微信连接
	if err1 != nil {
		return err1
	}
	wxSvc := refunddomestic.RefundsApiService{Client: client}
	for k, v := range dealReturnOrdMapForWx {
		resp, _, err6 := wxSvc.Create(c,
			refunddomestic.CreateRequest{
				SubMchid:    core.String(v.WxMchId),
				OutTradeNo:  core.String(k),
				OutRefundNo: core.String(v.OutRequestNo),
				Reason:      core.String("央厨订餐退款"),
				NotifyUrl:   core.String(sysCfg[enum.WxJsapiRefundPayNotifyUrl]),
				Amount: &refunddomestic.AmountReq{
					Currency: core.String("CNY"),
					Refund:   core.Int64(int64(math.Round(v.Amount * 100))),
					Total:    core.Int64(int64(math.Round(utils.StrToFloat64(v.Total) * 100))),
				},
			},
		)

		fmt.Println(">>>>wxRefund<<<<", resp)

		if err6 != nil {
			fmt.Println("dealReturnOrdMapForWx_ERR::::", err6.Error())
			//TODO::1、将 central_kitchen_for_school_user_refund_day 审核状态修改为`退款中`
			var sql string
			parts := strings.Split(err6.Error(), "Message: ")
			if len(parts) > 1 {
				// 去除"Message:"后面的换行符和空格
				message := strings.TrimSpace(parts[1])
				sql = fmt.Sprintf("update central_kitchen_for_school_user_refund_day set state =5, memo = '%s' where out_request_no = '%s'", message, v.OutRequestNo)
			} else {
				sql = fmt.Sprintf("update central_kitchen_for_school_user_refund_day set state =5, memo = '%s' where out_request_no = '%s'", err6.Error(), v.OutRequestNo)
			}
			db.ExecuteOriginalSql(db.Db, sql)

			//TODO::2、将 central_kitchen_for_school_user_with_day 修改状态为退款中
			sql1 := "update central_kitchen_for_school_user_with_day set state = %d where id In  (%s)"
			idsStr := strings.Join(dealReturnOrd[k], ",")
			sql1 = fmt.Sprintf(sql, enum.CentralKitchenForSchoolUserWithDayStateForCanceling, idsStr)
			db.ExecuteOriginalSql(db.Db, sql1)

			utils.FilePutContents("dealReturnOrdMapForWx_ERR", utils.SerializeStr(map[string]interface{}{
				"sql":  sql,
				"sql1": sql1,
				"err":  err6.Error(),
			}))
		} else {
			//TODO::处理订单状态
			err = svc.JudgePackageOrdOrdState(k)
			if err != nil {
				utils.FilePutContents("dealReturnOrdMapForWx_judge_packageOrdState_ERR", utils.SerializeStr(map[string]interface{}{
					"err": err.Error(),
				}))
			}
		}

		time.Sleep(10 * time.Millisecond) //TODO::避免频繁调用
	}
	//}

	return
}
