package model

type NursingHomePackage struct {
	Id           int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	EnterpriseId int    `json:"enterprise_id" xorm:"not null default 0 comment('所属单位id') INT(11)"`
	Year         string `json:"year" xorm:"not null default '0000' comment('年份') VARCHAR(50)"`
	Month        string `json:"month" xorm:"not null default '00' comment('月份') VARCHAR(50)"`
	TotalPrice   string `json:"total_price" xorm:"not null default 0.00 comment('总价') DECIMAL(8,2)"`
	StartDate    string `json:"start_date" xorm:"not null default '0000-00-00' comment('起始时间') CHAR(50)"`
	EndDate      string `json:"end_date" xorm:"not null default '0000-00-00' comment('截止时间') CHAR(50)"`
	State        int    `json:"state" xorm:"not null default 1 comment('状态(1:可用 2:不可用)') TINYINT(1)"`
	IsDelete     int    `json:"is_delete" xorm:"not null default 0 comment('是否删除(0:未删除 1:已删除)') TINYINT(1)"`
	CreateAt     string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt     string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
